package db;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;

import javax.annotation.PostConstruct;

@Configuration
public class Globals {
    // 魔数
    public static final int PROBE_MAGIC = 0x4E455344;
    public static final int WAL_ITEM_MAGIC = 0x9E26DF2A;
    public static final int LOG_ITEM_MAGIC = 0x352F6EA2;
    public static final int LOG_FILE_MAGIC = 0x2D70A3B5;
    public static final int VERSION = 0x21030001;

    // 类型
    public static final short TYPE_REQUEST = 0x1;
    public static final short TYPE_CONFIRM = 0x2;
    public static final short TYPE_RESPONSE = 0x3;
    public static final short TYPE_CLOSE = 0x4;

    // 响应码
    public static final short NONE = 0;
    public static final short RESPONSE_SUCCESS = 200;
    public static final short RESPONSE_ERROR = 400;
    public static final short RESPONSE_TIMEOUT = 408;
    public static final short RESPONSE_FAIL = 417;

    // 操作码
    public static final short OPERATION_LINK = 0x1;
    public static final short OPERATION_WRITE = 0x2;
    public static final short OPERATION_READ = 0x3;
    public static final short OPERATION_LISTEN_LOGIN = 0x4;
    public static final short OPERATION_LISTEN_CANCEL = 0x5;
    public static final short OPERATION_LISTEN_DATA = 0x6;
    public static final short OPERATION_SAVE_CONFIG = 0x7;
    public static final short OPERATION_SCAN = (short) 0xFFFF;

    // 报文码
    public static final short PACKAGE_BASE_INFO = 0x1;
    public static final short PACKAGE_STATE_INFO = 0x2;
    public static final short PACKAGE_CLIENT_INFO = 0x3;
    public static final short PACKAGE_TABLE = 0x4;
    public static final short PACKAGE_STRATEGY = 0x5;
    public static final short PACKAGE_LIMIT = 0x6;
    public static final short PACKAGE_LOCK = 0x7;


    public static int MAX_LOG_ITEM = 1024 * 64;

    public static String BROADCAST_HOST = "255.255.255.255";
    public static final int BROADCAST_PORT = 1200;

    @Value("${ip.broadcast}")
    private String ipBroadcast;
    @Value("${system.data-file.max-item}")
    private Integer maxLogItem;

    @PostConstruct
    public void init(){
        Globals.BROADCAST_HOST = ipBroadcast;
        Globals.MAX_LOG_ITEM = maxLogItem;
    }
}
