package db.entity;

public enum MsgType {
    SUCCESS(200, "SUCCESS"),
    FAILED(1000, "FAILURE"),

    // 用户错误
    PARAM_IS_INVALID(1001, "PARAM IS INVALID"),
    PERMISSION_DENIED(1002, "PERMISSION DENIED"),
    NOT_LOGIN(1003, "NOT LOGIN"),


    // 系统错误
    SERVER_ERROR(1500, "SERVER ERROR"),
    NOT_IMPLEMENT(1501, "NOT IMPLEMENT");

    private Integer code;
    private String message;

    MsgType() {
    }

    MsgType(Integer code) {
        this.code = code;
    }

    MsgType(Integer code, String message) {
        this.code = code;
        this.message = message;
    }

    public Integer getCode() {
        return code;
    }

    public void setCode(Integer code) {
        this.code = code;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }
}
