package db.entity;

import db.entity.MsgType;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

@Data
@NoArgsConstructor
public class ResponseDto<T> implements Serializable {
    // 状态码
    private Integer code;
    // 信息
    private String msg;
    // 数据
    private T data;
    private Boolean success;

    public ResponseDto(Integer code, String message, Boolean success) {
        this.code = code;
        this.msg = message;
        this.success = success;
    }

    public ResponseDto(Integer code, String message, T data, Boolean success) {
        this.code = code;
        this.msg = message;
        this.data = data;
        this.success = success;
    }

    public ResponseDto(T data, String memo) {
        this.code = MsgType.SUCCESS.getCode();
        this.msg = MsgType.SUCCESS.getMessage();
        this.data = data;
        this.success = true;
    }


}
