package db.util;


import db.entity.MsgType;
import db.entity.ResponseDto;

import java.util.Random;

public class ResponseUtils {
    public static <T> ResponseDto<T> success(T object) {
        return new ResponseDto<T>(object, "");
    }

    public static ResponseDto success() {
        return new ResponseDto(MsgType.SUCCESS.getCode(), MsgType.SUCCESS.getMessage(), "", true);
    }


    public static ResponseDto failed(MsgType msgType) {
        return new ResponseDto(msgType.getCode(), msgType.getMessage(), "", true);
    }

    public static ResponseDto failed(MsgType msgType, String msg) {
        Random r = new Random();
        return new ResponseDto(msgType.getCode(), msg, "", false);
    }

    public static ResponseDto failed(String msg) {
        return new ResponseDto(MsgType.FAILED.getCode(), msg, "", false);
    }

    public static ResponseDto failed() {
        return new ResponseDto(MsgType.FAILED.getCode(), "操作失败", "", false);
    }
}
