package db;

import db.util.Util;

import java.io.Serializable;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;


public class PointVals implements Serializable {
	private static final long serialVersionUID = 1L;
	private Point point;
	private int count;
	private long[] utcTimes; // 数值型实时UTC时间
	private double[] values; // 数值型实时数值
	private int beginIndex = 0;

	public PointVals(Point point, int count, long[] utcTimes, double[] values) {
		this.point = point;
		this.count = count;
		this.utcTimes = utcTimes;
		this.values = values;
	}

	private String[] toDateArray(long[] utcTimes) {
		String[] result = new String[utcTimes.length];
		for (int i=0;i<utcTimes.length;i++) {
			result[i] = Util.uTCMilliSecondsToDateStringWithMs(utcTimes[i]);
		}
		return result;
	}

	@Override
	public String toString() {
		return "PointVals{" +
				"point=" + point +
				", count=" + count +
				", utcTimes=" + Arrays.toString(toDateArray(utcTimes)) +
				", utcTimes=" + Arrays.toString(utcTimes) +
				", values=" + Arrays.toString(values) +
				", beginIndex=" + beginIndex +
				'}';
	}

	public PointVals() {}

	public String getMetricName() {
		return this.point.getMetricName();
	}

	public void setMetricName(String metricName) {
		this.point.setMetricName(metricName);
	}

	public void setBeginIndex(int beginIndex) {
		this.beginIndex = beginIndex;
	}

	public Map<String, String> getTags() {
		return this.point.getTags();
	}

	public void setTags(HashMap<String, String> tags) {
		this.point.setTags(tags);
	}

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public long getUtcTime(int index) {
		return this.utcTimes[beginIndex+index];
	}

	public double getValue(int index) {
		return this.values[beginIndex+index];
	}
	public String getFinalMetricName(String metricNamePrefix) {
		return metricNamePrefix + this.getMetricName();
	}

	public boolean isEmpty() {
		return count==0;
	}

	public PointVals subPointVals(int begin, int end) {
		int count = end-begin;
		PointVals resultPointVals = new PointVals(this.point, count, this.utcTimes, this.values);
		resultPointVals.setBeginIndex(begin);
		return resultPointVals;
	}
}

