package db.page;


import db.DBVal;

import java.util.List;

/**
 * 功能描述
 *
 * @author: scott
 * @date: 2022年09月27日 10:01 AM
 */
public class RangePagingQuery implements db.page.PagingQuery {
    int pageSize;
    int pageCount;
    long start;
    long end;
    List<DBVal> result;
    public RangePagingQuery(long start, long end, int pageSize, int pageCount,
                            List<DBVal> result) {
        this.pageSize = pageSize;
        this.pageCount = pageCount;
        this.start = start;
        this.end = end;
        this.result = result;
    }

    public int getPageSize() {
        return pageSize;
    }

    public int getPageCount() {
        return pageCount;
    }

    public long getStart() {
        return start;
    }

    public long getEnd() {
        return end;
    }

    public int getTotalCount() {
        return this.result.size();
    }

    public List<DBVal> getAllResult() {
        return result;
    }

    public List<DBVal> getPage(int pageIndex) throws Exception {
//        if(this.pageCount==0&&pageIndex==0) {
//            return new ArrayList<>();
//        }

        if(pageIndex>=pageCount || pageIndex<0) throw new Exception("pageIndex>=pageCount || pageIndex<0");

        int start = pageIndex*pageSize;
        int end;
        if((pageIndex+1)*pageSize>result.size())
            end = result.size();
        else end = (pageIndex+1)*pageSize;

        return result.subList(start, end);
    }
}
