package db.config;

import db.DBApiEntry;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
@Slf4j
public class DBConfig {

    @Value("${reso-db.host}")
    private String host;

    @Value("${reso-db.port}")
    private int port;


    @Bean
    public DBApiEntry dbApiEntry() {
        log.info("DB init");
        return DBApiEntry.initApiEntry(host, port);
    }
}
