package db.controller;

import db.dto.StatisticDto;
import db.entity.ResponseDto;
import db.service.StatisticService;
import db.util.ResponseUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;


@RestController
@Slf4j
@RequestMapping("/manage")
public class StatisticController {

    @Autowired
    private StatisticService statisticService;

    @RequestMapping("/statistic")
    public ResponseDto<StatisticDto> queryStatistic() {
        log.info("==> [api查看统计] 收到查看探针请求");

        StatisticDto statisticDto = statisticService.getStatistic().toDto();

        ResponseDto<StatisticDto> ret;

        ret = ResponseUtils.success(statisticDto);

        log.info("<== [api查看统计] {}", ret);
        return ret;
    }


    @RequestMapping("/logShowStatistic")
    public String logShowStatistic(@RequestParam String mode) {
        log.info("收到logShowStatistic请求");
        if("enable".equals(mode)) {
            statisticService.setShowStatisticAfterInsertData(true);
        }
        else {
            statisticService.setShowStatisticAfterInsertData(false);
        }
        return "成功";
    }
}
