package db.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import db.util.Util;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.text.ParseException;

@Data
@NoArgsConstructor
public class StatisticDto {
    @JsonProperty("beginTime")
    String beginTimeString;
    @JsonIgnore
    long beginTime;
    long runningTime;
    long dataCount;
    long dataCountTsdbSuccess;
    long dataCountDiskSuccess;
    double dataRate;
    double dataCountTsdbSuccessRate;
    double dataCountDiskSuccessRate;

    public StatisticDto(long beginTime, long dataCount, long dataCountTsdbSuccess, long dataCountDiskSuccess) {
        this.beginTime = beginTime;
        this.dataCount = dataCount;
        this.dataCountTsdbSuccess = dataCountTsdbSuccess;
        this.dataCountDiskSuccess = dataCountDiskSuccess;
        this.runningTime = System.currentTimeMillis() - this.beginTime;
        this.dataRate = this.dataCount * 1000.0 / this.runningTime;
        this.dataCountTsdbSuccessRate = this.dataCountTsdbSuccess * 1000.0 / this.runningTime;
        this.dataCountDiskSuccessRate = this.dataCountDiskSuccess * 1000.0 / this.runningTime;

        try {
            beginTimeString = Util.uTCMilliSecondsToDateString(this.beginTime);
        } catch (ParseException e) {
            beginTimeString = "";
        }

    }
}
