package db.entity;

import db.dto.ProbeDto;
import db.dto.StatisticDto;
import db.entity.packages.ScanResponsePackage;
import db.util.ConvertUtils;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

@Data
@Slf4j
@NoArgsConstructor
@AllArgsConstructor
public class Probe {
    private short id;
    private long mac;
    private int ip;
    private int mask;
    private byte clockMode;
    private byte eE1LinkState;
    private byte eE1LinkDeviceType;
    private byte eE1LinkDevicePort;
    private short eE1LinkDeviceId;
    private byte eE2LinkState;
    private byte eE2LinkDeviceType;
    private byte eE2LinkDevicePort;
    private short eE2LinkDeviceId;
    private byte e0linkState;
    private byte e1LinkState;
    private byte e2LinkState;
    private byte e3LinkState;
    private byte e4LinkState;
    private byte e5LinkState;
    private byte e6LinkState;
    private byte e7LinkState;
    private byte clockSource;

    public void updateFromScanResponsePackage (ScanResponsePackage scanResponsePackage) {
        this.id = scanResponsePackage.getId();
        this.mac = scanResponsePackage.getMac();
        this.ip = scanResponsePackage.getIp();
        this.mask = scanResponsePackage.getMask();
        this.clockMode = scanResponsePackage.getClockMode();
        this.eE1LinkState = scanResponsePackage.getEE1LinkState();
        this.eE1LinkDeviceType = scanResponsePackage.getEE1LinkDeviceType();
        this.eE1LinkDevicePort = scanResponsePackage.getEE1LinkDevicePort();
        this.eE1LinkDeviceId = scanResponsePackage.getEE1LinkDeviceId();
        this.eE2LinkState = scanResponsePackage.getEE2LinkState();
        this.eE2LinkDeviceType = scanResponsePackage.getEE2LinkDeviceType();
        this.eE2LinkDevicePort = scanResponsePackage.getEE2LinkDevicePort();
        this.eE2LinkDeviceId = scanResponsePackage.getEE2LinkDeviceId();
        this.e0linkState = scanResponsePackage.getE0linkState();
        this.e1LinkState = scanResponsePackage.getE1LinkState();
        this.e2LinkState = scanResponsePackage.getE2LinkState();
        this.e3LinkState = scanResponsePackage.getE3LinkState();
        this.e4LinkState = scanResponsePackage.getE4LinkState();
        this.e5LinkState = scanResponsePackage.getE5LinkState();
        this.e6LinkState = scanResponsePackage.getE6LinkState();
        this.e7LinkState = scanResponsePackage.getE7LinkState();
        this.clockSource = scanResponsePackage.getClockSource();
    }

    public ProbeDto toDto() {
        ProbeDto probeDto = new ProbeDto(this);
        return probeDto;
    }

    @Override
    public String toString() {
        return "Probe{" +
                "id=" + id +
                ", mac=" + ConvertUtils.longMac2String(mac) +
                ", ip=" + ConvertUtils.ip2String(ip) +
                ", mask=" + ConvertUtils.ip2String(mask) +
                ", clockMode=" + Integer.toHexString(clockMode) +
                ", eE1LinkState=" + Integer.toHexString(eE1LinkState) +
                ", eE1LinkDeviceType=" + Integer.toHexString(eE1LinkDeviceType) +
                ", eE1LinkDevicePort=" + eE1LinkDevicePort +
                ", eE1LinkDeviceId=" + eE1LinkDeviceId +
                ", eE2LinkState=" + Integer.toHexString(eE2LinkState) +
                ", eE2LinkDeviceType=" + Integer.toHexString(eE2LinkDeviceType) +
                ", eE2LinkDevicePort=" + eE2LinkDevicePort +
                ", eE2LinkDeviceId=" + eE2LinkDeviceId +
                ", e0linkState=" + Integer.toHexString(e0linkState) +
                ", e1LinkState=" + Integer.toHexString(e1LinkState) +
                ", e2LinkState=" + Integer.toHexString(e2LinkState) +
                ", e3LinkState=" + Integer.toHexString(e3LinkState) +
                ", e4LinkState=" + Integer.toHexString(e4LinkState) +
                ", e5LinkState=" + Integer.toHexString(e5LinkState) +
                ", e6LinkState=" + Integer.toHexString(e6LinkState) +
                ", e7LinkState=" + Integer.toHexString(e7LinkState) +
                ", clockSource=" + Integer.toHexString(clockSource) +
                '}';
    }
}
