package db;

import lombok.extern.slf4j.Slf4j;
import org.pcap4j.core.PcapHandle;
import org.pcap4j.core.PcapNativeException;
import org.pcap4j.core.Pcaps;
import org.pcap4j.packet.EthernetPacket;
import org.pcap4j.packet.Packet;
import org.pcap4j.packet.namednumber.EtherType;

@Slf4j
public class Test {

    private static final int COUNT = 5;
    private static final String PCAP_FILE = "./pcap/udp.pcap";

    public static void main(String[] args) throws PcapNativeException{
        PcapHandle handle;
        try {
            handle = Pcaps.openOffline(PCAP_FILE, PcapHandle.TimestampPrecision.NANO);
        } catch (PcapNativeException e) {
            e.printStackTrace();
            handle = Pcaps.openOffline(PCAP_FILE);
        }

        for (int i = 0; i < COUNT; i++) {
            try {
                Packet packet = handle.getNextPacketEx();
                System.out.println(packet.contains(EthernetPacket.class));

                if (packet.contains(EthernetPacket.class)) {
                    EthernetPacket ethernetPacket = packet.get(EthernetPacket.class);
                }

                System.out.println(handle.getTimestamp());
                System.out.println(packet);
            } catch (Exception e) {
                System.out.println("EOF");
                break;
            }
        }

        handle.close();
    }
}
