package db.data;

import db.entity.packages.DataResponsePackage;
import db.util.Config;
import db.util.ContentUtils;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * 功能描述
 *
 * @author: scott
 * @date: 2022年12月29日 2:12 PM
 */
public class DataGenerator {
    private static final long SMAC = 0x000002555559L;
    private static final long DMAC = 0x000002444455L;
    String toHost = Config.getInstance().blackboxServer();
    int toPort = Config.getInstance().blackboxServerPort();
    String sIP = Config.getInstance().sIP();
    String dIP = Config.getInstance().dIP();
    short sPort = Config.getInstance().sPort();
    short dPort = Config.getInstance().dPort();

    short curDPort = 0;

    public DataGenerator(String toHost, int toPort) {
        this.toHost = toHost;
        this.toPort = toPort;
    }

    public DataGenerator() {

    }

    public DataResponsePackage generate() {
        curDPort++;
        return generateDataPackage(this.toHost, this.toPort,
                new Date(), this.sIP, this.dIP, this.sPort, curDPort);
    }

    public List<DataResponsePackage> generate(int count) {
        List<DataResponsePackage> packages = new ArrayList<>(count);
        for(int i=0;i<count;i++) {
            curDPort++;
            DataResponsePackage p = generateDataPackage(this.toHost, this.toPort,
                    new Date(), this.sIP, this.dIP, this.sPort, curDPort);
            packages.add(p);
        }
        return packages;
    }

    public static DataResponsePackage generateDataPackage(String toHost, int toPort,
                                                          Date date, String sIP, String dIP,
                                                          short sPort, short dPort) {
        short responseCode = 200;
        short packageCode = 0;
        short probeId = 0x0010;
        byte port = 0x01;
        byte dataStrategy = 0;
        byte clockSync = (byte) 0xAA;

//        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);

        short year = (short) cal.get(Calendar.YEAR);
        short day = (short) cal.get(Calendar.DAY_OF_YEAR);
        short hour = (short) cal.get(Calendar.HOUR_OF_DAY);
        short minute = (short) cal.get(Calendar.MINUTE);
        short second = (short) cal.get(Calendar.SECOND);
        int microSecond = cal.get(Calendar.MILLISECOND) * 1000;
        byte[] data = ContentUtils.generateData(SMAC, DMAC , sIP,
                dIP, sPort, dPort);
        DataResponsePackage dataResponsePackage = new DataResponsePackage(responseCode, packageCode, probeId,
                port, dataStrategy, clockSync, year, day, hour, minute, second, microSecond, data);
        dataResponsePackage.setToHostPort(toHost, toPort);
        return dataResponsePackage;
    }
}
