package db.util;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

public class Config {
    static String configFile = "conf/probe/probe.properties";
    private static Config config = null;
    private ResourceBundle resource;

    public static void setConfigFile(String configFile) {
        Config.configFile = configFile;
    }

    public static String getConfigFile() {
        return Config.configFile;
    }
    public Config() {
        try {
            InputStream inputStream = new BufferedInputStream(
                    new FileInputStream(new File(configFile)));
            resource = new PropertyResourceBundle(inputStream);
        } catch (Exception e) {
            e.printStackTrace();
            return;
        }
    }

    public String blackboxServer() {
        return this.resource.getString("blackboxServer");
    }
    public String sIP() {
        return this.resource.getString("sIP");
    }

    public String dIP() {
        return this.resource.getString("dIP");
    }

    public short sPort() {
        return Short.parseShort(this.resource.getString("sPort"));
    }

    public short dPort() {
        return Short.parseShort(this.resource.getString("dPort"));
    }

    public int packetNumPerSecond() {
        return Integer.parseInt(this.resource.getString("packetNumPerSecond"));
    }
    public int probeID() {
        return Integer.parseInt(this.resource.getString("probeID"));
    }
    public int blackboxServerPort() {
        return Integer.parseInt(this.resource.getString("blackboxServerPort"));
    }

    public boolean sendTestData() {
        return Integer.parseInt(this.resource.getString("sendTestData"))!=0;
    }

    public static Config getInstance() {
        if(config==null) {
            config = new Config();
        }
        return config;
    }
}
