package db.entity.packages;

import db.Globals;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import lombok.Data;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

@Data
@Slf4j
@ToString(callSuper = true)
public class ClientReadRequestPackage extends BasePackage {

    private Byte port;

    public ClientReadRequestPackage() {
        super(Globals.TYPE_REQUEST, Globals.NONE, Globals.OPERATION_READ, Globals.PACKAGE_CLIENT_INFO, (short) 1);
    }

    @Override
    public void setPayload(ByteBuf buf) {
        port = buf.readByte();
    }

    @Override
    public ByteBuf getPayload() {
        ByteBuf buf = Unpooled.buffer(1);
        buf.writeByte(port);
        return buf;
    }

}
