package db.entity.packages;

import db.Globals;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import lombok.Data;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

@Data
@Slf4j
@ToString(callSuper = true)
public class LimitWriteRequestPackage extends BasePackage {

    private Byte isLimit;
    private Short frameSize;

    public LimitWriteRequestPackage() {
        super(Globals.TYPE_REQUEST, Globals.NONE, Globals.OPERATION_WRITE, Globals.PACKAGE_LIMIT, (short) 3);
    }

    @Override
    public void setPayload(ByteBuf buf) {
        isLimit = buf.readByte();
        frameSize = buf.readShort();
    }

    @Override
    public ByteBuf getPayload() {
        ByteBuf buf = Unpooled.buffer(3);
        buf.writeByte(isLimit);
        buf.writeShort(frameSize);
        return buf;
    }

    @Override
    public String toString() {
        return "LimitWriteRequestPackage{" +
                "isLimit=" + Integer.toHexString(isLimit) +
                ", frameSize=" + frameSize +
                "} " + super.toString();
    }
}
