package db.entity.packages;

import db.Globals;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

@Data
@NoArgsConstructor
@Slf4j
@ToString(callSuper = true)
public class ListenRequestPackage extends BasePackage {

    private byte listenMode;

    public ListenRequestPackage(short operationCode, byte listenMode) {
        super(Globals.TYPE_REQUEST, Globals.NONE, operationCode, Globals.NONE, (short) 1);
        this.listenMode = listenMode;
    }

    @Override
    public void setPayload(ByteBuf buf) {
        listenMode = buf.readByte();
    }

    @Override
    public ByteBuf getPayload() {
        ByteBuf buf = Unpooled.buffer(1);
        buf.writeByte(listenMode);
        return buf;
    }

    @Override
    public String toString() {
        return "ListenRequestPackage{" +
                "listenMode=" + Integer.toHexString(listenMode) +
                "} " + super.toString();
    }
}
