package db.entity.packages;

import db.Globals;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import lombok.Data;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

@Data
@Slf4j
@ToString(callSuper = true)
public class LockWriteRequestPackage extends BasePackage {

    private Byte lockState;

    public LockWriteRequestPackage() {
        super(Globals.TYPE_REQUEST, Globals.NONE, Globals.OPERATION_WRITE, Globals.PACKAGE_LOCK, (short) 1);
    }

    @Override
    public void setPayload(ByteBuf buf) {
        lockState = buf.readByte();
    }

    @Override
    public ByteBuf getPayload() {
        ByteBuf buf = Unpooled.buffer(1);
        buf.writeByte(lockState);
        return buf;
    }

    @Override
    public String toString() {
        return "LockWriteRequestPackage{" +
                "lockState=" + Integer.toHexString(lockState) +
                "} " + super.toString();
    }
}
