package db;

import db.service.QueryService;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.pcap4j.core.NotOpenException;
import org.pcap4j.core.PcapNativeException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.IOException;
import java.text.ParseException;
import java.util.HashMap;

@SpringBootTest
@Slf4j
@RunWith(SpringRunner.class)
public class QueryTest {

    @Autowired
    private QueryService queryService;

    @Test
    public void queryByTimeAndConditionTest() throws ParseException, IOException, NotOpenException, PcapNativeException {
        String start = "2022-10-27 10:00:00";
        String end = "2023-01-27 00:00:01";
        HashMap<String, String> tags = new HashMap<>();
//        tags.put("pointName", "pointName_test111");
//        tags.put("status", "3");
        log.debug("---queryByTimeAndCondition---");
        queryService.queryByTimeAndCondition(start, end, tags);
    }

    @Test
    public void queryByTimeTest() throws ParseException, IOException, PcapNativeException, NotOpenException {
        String start = "2022-10-27 10:00:00";
        String end = "2023-01-27 00:00:01";
        log.debug("---queryByTime---");
        String res = queryService.queryByTime(start, end);
        log.debug("res:{}",res);


    }
}
